LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.all;
	  

ENTITY cardcounter IS
     PORT(clock 		: IN	STD_LOGIC;
   		reset  		: IN    STD_LOGIC;		
   		issued		: IN	STD_LOGIC;
   		card		: IN	STD_LOGIC_VECTOR (3 downto 0);
   		over_reset	: in std_logic;
   		house_card_dealt : in std_logic;
   		stat_ace 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_two 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_three 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_four 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_five 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_six 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_seven 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_eight 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_nine 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_ten 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_jack	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_queen	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_king 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
   	  	face_chance : out std_logic_vector(2 downto 0);
		dealttotal_out : out std_logic_vector(7 downto 0)
   );  
   
END cardcounter;

--
ARCHITECTURE cc_arch OF cardcounter IS	 

signal ace_test :  integer range 0 to 16;
signal face_test :  integer range 0 to 64;
signal 
prob_ace_test	 : integer range 0 to 100;
signal 
prob_face_test     : integer range 0 to 100;
signal rdeck_test : integer range 0 to 208;


BEGIN

		



   	process(reset,issued,over_reset,house_card_dealt)
   	
   	 variable ace	: STD_LOGIC_VECTOR (4 downto 0) ;
		variable two 		: STD_LOGIC_VECTOR (4 downto 0);
		variable three 	: STD_LOGIC_VECTOR (4 downto 0);
		variable four 	: STD_LOGIC_VECTOR (4 downto 0);
		variable five 	: STD_LOGIC_VECTOR (4 downto 0);
		variable six 		: STD_LOGIC_VECTOR (4 downto 0);
		variable seven 	: STD_LOGIC_VECTOR (4 downto 0);
		variable eight 	: STD_LOGIC_VECTOR (4 downto 0);
		variable nine 	: STD_LOGIC_VECTOR (4 downto 0);
		variable ten 		: STD_LOGIC_VECTOR (4 downto 0);
		variable jack		: STD_LOGIC_VECTOR (4 downto 0);
		variable queen	: STD_LOGIC_VECTOR (4 downto 0);
		variable king 	: STD_LOGIC_VECTOR (4 downto 0);
				
		variable dealttotal : std_logic_vector(7 downto 0);
		variable rdeck : std_logic_vector(7 downto 0);
		variable totaldeck : std_logic_vector(7 downto 0);
		
		variable ace_intern : integer range 0 to 16;
		variable face_intern : integer range 0 to 64;
		
		variable ace_prob_unsign : unsigned (7 downto 0);
		variable face_prob_unsign : unsigned (7 downto 0); 
		variable ace_int : STD_LOGIC_VECTOR (4 downto 0) ;
		variable face_int : std_logic_vector(7 downto 0);
		variable face_dealt : std_logic_vector(7 downto 0);
		variable ace_prob_int : integer range 0 to 100;
		variable face_prob_int : integer range 0 to 100;
		
		
		variable rdeck_int : integer range 0 to 208;	
		
   	   	
	begin
	
	       
	
 --  		if clock'event and clock = '1' then
   	
      		if ( ( reset = '1')  or  over_reset ='1') then 
				ace := "00000"; two := "00000"; three := "00000"; four := "00000";
				five := "00000"; six := "00000"; seven := "00000"; eight := "00000";
				nine :="00000"; ten := "00000"; jack:= "00000"; queen := "00000";
				king := "00000";
dealttotal:="00000000"; rdeck := "11010000";
				totaldeck := "11010000";face_dealt := "00000000"  ;
				face_chance<= "010";
				
			
				
			else
			        if (   house_card_dealt ='1' OR ( issued'event and issued = '1')) then
				  
				case card is
					when "0001" =>
					ace := ace + 1;
					dealttotal:= (dealttotal + 1); 
					when "0010" =>
					two := two + 1;
					dealttotal:= (dealttotal + 1); 
					when "0011" =>
					three := three + 1;
					dealttotal:= (dealttotal + 1); 
					when "0100" =>
					four := four + 1;
					dealttotal:= (dealttotal + 1); 
					when "0101" =>
					five := five + 1;
					dealttotal:= (dealttotal + 1); 
					when "0110" =>
					six := six + 1;
					dealttotal:= (dealttotal + 1); 
					when "0111" =>
					seven := seven + 1;
					dealttotal:= (dealttotal + 1); 
					when "1000" =>
					eight := eight + 1;
					dealttotal:= (dealttotal + 1); 
					when "1001" =>
					nine := nine + 1;
					dealttotal:= (dealttotal + 1); 
					when "1010" =>
					ten := ten + 1;
					face_dealt:=face_dealt + 1;
					dealttotal:= (dealttotal + 1); 
					when "1011" =>
					jack := jack + 1;
					face_dealt:=face_dealt + 1;
					dealttotal:= (dealttotal + 1); 
					when "1100" =>
					queen := queen + 1;
					face_dealt:=face_dealt + 1;
					dealttotal:= (dealttotal + 1); 
					when "1101" =>
					king := king + 1;
					face_dealt:=face_dealt + 1;
					dealttotal:= (dealttotal + 1); 
					when OTHERS =>
					
					end case;
					
					 
			   		rdeck:= (totaldeck - dealttotal);
			   		
			   		rdeck_int :=conv_integer(rdeck);
			   		
			   		rdeck_test <= rdeck_int;
			   		
			   		 ace_int := ( "10000" - ace);
					face_int :=( "1000000" - face_dealt);
					
							
					ace_intern := conv_integer(ace_int);
					face_intern :=conv_integer(face_int);
					
					ace_test <=ace_intern;
					face_test<=face_intern; 
							
					ace_prob_int:= ((ace_intern*100)/rdeck_int);
					face_prob_int := ((face_intern*100)/rdeck_int); 
						
						if (face_prob_int = 0 ) then 
						
						face_chance<= "000";
						
						elsif (face_prob_int < 20 ) then
						
						face_chance<= "001";
						
						elsif (face_prob_int < 40 ) then
						
						face_chance<= "010";
						
						elsif (face_prob_int < 60 ) then
						
						face_chance<= "011";
						
						elsif (face_prob_int < 80 ) then
						
						face_chance<= "100";
						
						elsif ( face_prob_int > 80 ) then
						
						face_chance<= "101";
						
						end if;
										
						prob_ace_test <= ace_prob_int;
	 					prob_face_test <=face_prob_int;
	 					
			   		
			   			end if;
			
						end if;
						
	stat_ace <= ace; stat_two <= two; stat_three <= three; stat_four <= four; stat_five <= five; stat_six <=six;
	stat_seven <= seven; stat_eight <= eight; stat_nine <= nine; stat_ten <= ten; stat_jack <= jack; 
	stat_queen <= queen; stat_king <= king;
dealttotal_out <=dealttotal;	
	end process;
	

	
	                               
	
END cc_arch;
